<!DOCTYPE html>
<html>

<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />

    <title>Flappy Penguin</title>

    <!-- Babylon.js -->
    <script src="https://code.jquery.com/pep/0.4.2/pep.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/dat-gui/0.6.2/dat.gui.min.js"></script>
    <script src="https://cdn.babylonjs.com/ammo.js"></script>
    <script src="https://cdn.babylonjs.com/cannon.js"></script>
    <script src="https://cdn.babylonjs.com/Oimo.js"></script>
    <script src="https://cdn.babylonjs.com/libktx.js"></script>
    <script src="https://cdn.babylonjs.com/earcut.min.js"></script>
    <script src="https://cdn.babylonjs.com/babylon.js"></script>
    <script src="https://cdn.babylonjs.com/inspector/babylon.inspector.bundle.js"></script>
    <script src="https://cdn.babylonjs.com/materialsLibrary/babylonjs.materials.min.js"></script>
    <script src="https://cdn.babylonjs.com/proceduralTexturesLibrary/babylonjs.proceduralTextures.min.js"></script>
    <script src="https://cdn.babylonjs.com/postProcessesLibrary/babylonjs.postProcess.min.js"></script>
    <script src="https://cdn.babylonjs.com/loaders/babylonjs.loaders.js"></script>
    <script src="https://cdn.babylonjs.com/serializers/babylonjs.serializers.min.js"></script>
    <script src="https://cdn.babylonjs.com/gui/babylon.gui.min.js"></script>


    <style>
        html,
        body {
            overflow: hidden;
            width: 100%;
            height: 100%;
            margin: 0;
            padding: 0;
        }

        #renderCanvas {
            width: 100%;
            height: 100%;
            touch-action: none;
        }
    </style>
</head>

<body>
    <canvas id="renderCanvas"></canvas>
    <script>
        /////////////////////////////////////// GLOBAL VARS ///////////////////////////////////////
        var canvas = document.getElementById("renderCanvas");
        var engine = null;
        var scene = null;
        var createDefaultEngine = function () { return new BABYLON.Engine(canvas, true, { preserveDrawingBuffer: true, stencil: true }); };
        var advancedTexture = null
        var obstaclesMesh = null
        var gameRunning = false
        var player = null
        var physicsEngine = null
        let date = new Date()
        var seconds = date.getSeconds()
        var iceMaterial = null
        var snowMaterial = null


        let obstacles = []
        /////////////////////////////////////// CREATE SCENE ///////////////////////////////////////
        var createScene = function () {
            initialize()
            return scene;
        }

        engine = createDefaultEngine();
        if (!engine) throw 'engine should not be null.';
        scene = createScene();

        engine.runRenderLoop(function () {
            if (scene) {
                loop()
                scene.render();
                date = new Date()
            }
        });

        // Resize
        window.addEventListener("resize", function () {
            engine.resize();
        });


        /////////////////////////////////////// INITIALIZE FUNCTIONS///////////////////////////////////////
        function initialize() {
            // Create the scene space
            scene = new BABYLON.Scene(engine);
            scene.clearColor = new BABYLON.Color3(0.00, 0.58, 0.94);

            // Enable physics to the scene
            scene.enablePhysics(null, new BABYLON.CannonJSPlugin());
            physicsEngine = scene.getPhysicsEngine();

            createCamera()
            createLights()
            createMaterials()
            createField()
            homeMenu()
        }

        function loop() {
          if (gameRunning) {
            toDelete = []
            let now = date.getSeconds()
            if(player.getY() < -5) {
              gameOver()
              obstacles.forEach((item,i ) => {
                  item.dispose()
                  toDelete.push(i)
              })
              toDelete.forEach((item,i ) => {
                obstacles.splice(item, 1)
              })
            }
            if (Math.abs(seconds - now) >= 0.5) {
              obstacles.forEach((item,i ) => {
                if(item.position.y > player.getY() && player.getY() < item.position.y + item.scaling.y && player.getX() >= item.position.x && player.getX() <= item.position.x + item.scaling.x){
                  item.dispose()
                  toDelete.push(i)
                  gameOver()
                }
                item.position.x -= 0.1
                if(item.position.x < -10) {
                  item.dispose()
                  toDelete.push(i)
                }
              })
              toDelete.forEach((item,i ) => {
                obstacles.splice(item, 1)
              })
            }
            if (Math.abs(seconds - now) >= 2) {
              createObstacle()
              seconds = now
            }
          }

        }
        function createObstacle() {
          h = Math.random()*3
          p = Math.random()* 3
          block = BABYLON.MeshBuilder.CreateBox("wall", { width: 1, depth: 1, height: h }, scene);
          block.material = iceMaterial
          position = Math.random()*2
          if(position > 1) {
            block.position.y = p;
            block.position.x = 9;
          }else {
            block.position.y = - p;
            block.position.x = 9;
          }
          obstacles.push(block)
        }
        function createCamera() {
            // Add a camera to the scene and attach it to the canvas
            var camera = new BABYLON.ArcRotateCamera("Camera", 0, 0, 0, BABYLON.Vector3.Zero(), scene);
            camera.setPosition(new BABYLON.Vector3(0, 5, -15));
            camera.attachControl(canvas, true);
        }

        function createField() {
            // Add a camera to the scene and attach it to the canvas
            // top
            for (let x = -10; x < 10; x++){
                let block = BABYLON.MeshBuilder.CreateBox("wall", { width: 1, depth: 1, height: 1 }, scene);
                block.material = snowMaterial
                block.position.y = 5;
                block.position.x = x;

               block = BABYLON.MeshBuilder.CreateBox("wall", { width: 1, depth: 1, height: 1 }, scene);
               block.material = snowMaterial
              block.position.y = -5;
              block.position.x = x;
            }
        }

        function createLights() {
            var light3 = new BABYLON.HemisphericLight("HemiLight", new BABYLON.Vector3(0, 1, 0), scene);
        }

        function createMaterials(){
            iceMaterial = new BABYLON.StandardMaterial("ice", scene);
            iceMaterial.diffuseTexture = new BABYLON.Texture("textures/ice.jpg", scene);
            iceMaterial.diffuseTexture.uScale = 1;
            iceMaterial.diffuseTexture.vScale = 1;

            snowMaterial = new BABYLON.StandardMaterial("ice", scene);
            snowMaterial.diffuseTexture = new BABYLON.Texture("textures/snow.jpg", scene);
            snowMaterial.diffuseTexture.uScale = 0.2;
            snowMaterial.diffuseTexture.vScale = 0.2;
        }


        /////////////////////////////////////// UI FUNCTIONS ///////////////////////////////////////
        function homeMenu() {
            advancedTexture = BABYLON.GUI.AdvancedDynamicTexture.CreateFullscreenUI("UI")
            var title = new BABYLON.GUI.TextBlock()
            title.text = "FLAPPY PENGUIN"
            title.color = "white"
            title.fontSize = 70
            title.top = -100
            advancedTexture.addControl(title)

            var startButton = BABYLON.GUI.Button.CreateSimpleButton("start", "START GAME");
            startButton.width = 0.2
            startButton.height = "40px"
            startButton.top = 50
            startButton.color = "white"
            startButton.background = "green"
            startButton.cornerRadius = 30
            advancedTexture.addControl(startButton);

            var helpButton = BABYLON.GUI.Button.CreateSimpleButton("start", "HELP | ABOUT");
            helpButton.width = 0.2
            helpButton.height = "40px"
            helpButton.top = 100
            helpButton.color = "white"
            helpButton.background = "blue"
            helpButton.cornerRadius = 30
            advancedTexture.addControl(helpButton);

            var array = [startButton, helpButton, title]

            startButton.onPointerClickObservable.add(function () {
                disposeObjects(array)
                startGame()

            });

            helpButton.onPointerClickObservable.add(function () {
                help()
            });

        }

        function inGameMenu(status, pts) {
            var box = new BABYLON.GUI.Rectangle();
            box.width = 0.6;
            box.height = 0.6;
            box.cornerRadius = 20;
            box.color = "white";
            box.thickness = 10;
            box.background = "green";
            advancedTexture.addControl(box);

            var title = new BABYLON.GUI.TextBlock()
            title.text = `Game ${status}`
            title.color = "white"
            title.fontSize = 60
            title.top = -100
            advancedTexture.addControl(title)

            var helpButton = BABYLON.GUI.Button.CreateSimpleButton("help", "HELP");
            helpButton.width = 0.2
            helpButton.height = "40px"
            helpButton.top = 50
            helpButton.color = "white"
            helpButton.background = "blue"
            helpButton.cornerRadius = 30
            advancedTexture.addControl(helpButton);

            var returnHomeButton = BABYLON.GUI.Button.CreateSimpleButton("returnhome", "MAIN MENU");
            returnHomeButton.width = 0.2
            returnHomeButton.height = "40px"
            returnHomeButton.top = 100
            returnHomeButton.color = "white"
            returnHomeButton.background = "red"
            returnHomeButton.cornerRadius = 30
            advancedTexture.addControl(returnHomeButton);

            if (status == 'paused') {
                var continueButton = BABYLON.GUI.Button.CreateSimpleButton("start", "CONTINUE")
                continueButton.width = 0.2
                continueButton.height = "40px"
                continueButton.top = 0
                continueButton.color = "white"
                continueButton.background = "brown"
                continueButton.cornerRadius = 30
                advancedTexture.addControl(continueButton);

                var array = [box, title, helpButton, returnHomeButton, continueButton]

                continueButton.onPointerClickObservable.add(function () {
                    disposeObjects(array)
                    gameRunning = true
                });
            }

            helpButton.onPointerClickObservable.add(function () {
                help()
            });
            returnHomeButton.onPointerClickObservable.add(function () {
                scene.dispose()
                scene = createScene()
            });
        }

        function help() {
            var helpBox = new BABYLON.GUI.Rectangle();
            helpBox.width = 0.9;
            helpBox.height = 0.9;
            helpBox.cornerRadius = 20;
            helpBox.color = "white";
            helpBox.thickness = 10;
            helpBox.background = "green";
            advancedTexture.addControl(helpBox);

            var howTo = new BABYLON.GUI.TextBlock()
            howTo.text = "How to Play"
            howTo.color = "white"
            howTo.fontSize = 40
            howTo.top = "-30%"
            advancedTexture.addControl(howTo)

            var instructions = new BABYLON.GUI.TextBlock()
            instructions.text = " OBJECTIVE: Try to make through as many obstacles without hitting \n\n\n-> Press SPACE to jump \n -> Press P to pause \n -> Press M to open help"
            instructions.color = "white"
            instructions.fontSize = 20
            instructions.top = "-10%"
            advancedTexture.addControl(instructions)

            var aboutUs = new BABYLON.GUI.TextBlock()
            aboutUs.text = "Eric Monné Mesalles - 183338 \n Karine Aparecida Pistili Rodrigues - 171469"
            aboutUs.color = "white"
            aboutUs.fontSize = 20
            aboutUs.top = "30%"
            advancedTexture.addControl(aboutUs)

            var closeButton = BABYLON.GUI.Button.CreateSimpleButton("start", "CLOSE X");
            closeButton.width = 0.1
            closeButton.height = "40px"
            closeButton.top = "-35%"
            closeButton.left = "35%"
            closeButton.color = "white"
            closeButton.background = "red"
            closeButton.cornerRadius = 30
            advancedTexture.addControl(closeButton);

            var array = [helpBox, closeButton, howTo, instructions, aboutUs]

            closeButton.onPointerClickObservable.add(function () {
                disposeObjects(array)
            })

        }

        // This functions receives an array of objects to be disposed
        function disposeObjects(array) {
            array.forEach(obj => {
                obj.dispose()
            });
        }

        /////////////////////////////////////// GAME FUNCTIONS ///////////////////////////////////////
        function startGame() {
            player = new Player()
            gameRunning = true
            keyboardControls()
        }

        function gameOver() {
            gameRunning = false
            inGameMenu('over', player.getScore())
        }

        function pauseGame() {
            gameRunning = false
            inGameMenu('paused', null)
        }

        function restartGame() {
            homeMenu()
        }

        // implement
        function moveObstacles() {
            var meshes = scene.getMeshesByID("obstacles");
            var lastX, lastY
            meshes.forEach(obstacle => {
                lastX = obstacle.position.x
                obstacle.position.x += 0.01
            });
        }

        /////////////////////////////////////// KEYBOARD LISTENERS ///////////////////////////////////////
        function keyboardControls() {
            document.addEventListener('keydown', function (key) {
                if (key.keyCode === 80) {
                    pauseGame()
                }
                if (key.keyCode === 77) {
                    help()
                }
                if (key.keyCode === 32) {
                    player.jump()
                }
            })
        }


        /////////////////////////////////////// CLASSES ///////////////////////////////////////
        class Player {
            score
            posX
            posY
            material
            size
            obj

            constructor() {
                this.score = 0
                this.posX = -3
                this.posY = 0
                this.posZ = 0
                this.size = 2
                this.loadGltfObject()

            }
            getX() {
              return this.obj?.position.x || this.posX
            }
            getY() {
              return this.obj?.position.y || this.posY
            }
            getScore() {
                return this.score
            }

            enablePhysics() {
                // add gravity physics to obj
                this.obj.physicsImpostor = new BABYLON.PhysicsImpostor(this.obj, BABYLON.PhysicsImpostor.BoxImpostor, { mass: 1.5, friction: 1.0, restitution: 0.3 }, scene);
            }
            async loadGltfObject() {
                var th = this
                new Promise(() => {
                    try {
                        BABYLON.SceneLoader.ImportMesh("", "penguin/", "scene.gltf", scene, function (newMesh) {
                            th.obj = newMesh[0]
                            th.obj.position.x = th.posX
                            th.obj.position.y = th.posY
                            th.obj.position.z = th.posZ
                            th.obj.scaling = new BABYLON.Vector3(0.2, 0.2, 0.2)

                            th.enablePhysics()
                        })
                    }
                    catch{
                        console.log('error')
                    }

                })
                    .then(() => {
                        console.log('loaded penguin')
                    })
                    .catch(() => {
                        console.log('error on loading penguin')
                    })
            }

            incrementScore() {
                this.score++
            }
            jump() {
                var impulseDirection = new BABYLON.Vector3(0, 1, 0);
                var impulseMagnitude = 8;
                var contactLocalRefPoint = BABYLON.Vector3.Zero();
                if (this.obj.position.y < 5 )
                  this.obj.physicsImpostor.applyImpulse(impulseDirection.scale(impulseMagnitude), this.obj.getAbsolutePosition().add(contactLocalRefPoint));
            }

        }

    </script>
</body>

</html>
